/************************************************************************************
****              Perodo para Apurao do Resultado Operacional                 ****
*************************************************************************************

Criado em  : 08/2007
       Por : Alessandra Cristina

Descrio:

      - Executa a procedure de apurao do resultado operacional para uma lista de
        filiais de acordo com o perodo precisto

      - Se no houver perodo parametrizado para a filial executa para a data de
        processamento da mesma.

      - Caso a filial seja uma Central Merenda(Pme) e a mesma esteja parametrizada
        suas agregadas tambm sero apuradas
Util :
       - Dir  : @C:\WEB_505\SQL\END_CONV\ORACLE\0019_GERSTPO_PERIODO_APURAC_RESOPERFIL.SQL

       - Erro : raise_application_error(-20501, 'Mensagem', True);
*/

CREATE OR REPLACE PROCEDURE PERIODO_APURAC_RESOPERFILI
                                (P_NRLISTA      IN VARCHAR)

IS
   V_DTINICIAL    DATE;
   V_DTFINAL      DATE;
   V_CDFILCENTPME VARCHAR2(4);
   V_IDTPAPURACAO VARCHAR2(1);

BEGIN

   V_CDFILCENTPME := '';
   FOR C_FILIAL IN(SELECT DISTINCT CDFILIAL, CDLISTA, IDFILIALAGRROP, CDFILCENTPME, NVL(IDTPAPURACAO, '3') AS IDTPAPURACAO, NVL(IDUTPADRROPFIL, 'N') AS IDUTPADRROPFIL
                    FROM ( SELECT F.CDFILIAL, CDLISTA, IDFILIALAGRROP, CDFILCENTPME, IDTPAPURACAO, IDUTPADRROPFIL
                              FROM LISTA L, FILIAL F, PARFILIALROP P, PARAMGERAL G
                              WHERE
                                    (NRLISTA       = P_NRLISTA)   AND
                                    (CDLISTA       = P.CDFILIAL)  AND
                                    (NVL(IDUTPADRROP,'N')   <> 'S')          AND
                                    ((CDLISTA      = F.CDFILIAL)
                                      OR ((CDFILCENTPME = CDLISTA)
                                      AND (IDFILIALAGRROP = 'S')))
                                      
                               UNION ALL

                               SELECT F.CDFILIAL, CDLISTA, IDFILIALAGRROP, CDFILCENTPME, IDTPAPURACAO, IDUTPADRROPFIL
                               FROM LISTA L, FILIAL F, PARFILIALROP P, PARAMGERAL G
                               WHERE
                                 (NRLISTA       = P_NRLISTA)  AND
                                 (P.CDFILIAL    = 'P')         AND
                                 (NVL(IDUTPADRROP,'N') = 'S')           AND
                                 ((CDLISTA      = F.CDFILIAL)
                                   OR ((CDFILCENTPME = CDLISTA)
                                   AND (IDFILIALAGRROP = 'S')))

                               )
                               ORDER BY CDFILCENTPME,CDLISTA, CDFILIAL
                               ) LOOP
                               
      V_IDTPAPURACAO := C_FILIAL.IDTPAPURACAO;
                               
      IF (C_FILIAL.CDFILIAL <> 'P') THEN
         IF (C_FILIAL.IDUTPADRROPFIL = 'S') THEN
		    BEGIN
			   SELECT NVL(IDTPAPURACAO, '3')
			     INTO V_IDTPAPURACAO
				 FROM PARFILIALROP P
				WHERE P.CDFILIAL = 'P';
			END;		
         END IF;
      END IF;

      IF (C_FILIAL.CDFILCENTPME IS NOT NULL) AND (C_FILIAL.IDFILIALAGRROP = 'S') AND
         (V_CDFILCENTPME <> C_FILIAL.CDFILCENTPME)  THEN
         V_CDFILCENTPME := C_FILIAL.CDFILCENTPME;
         BEGIN
            SELECT NVL(DTINIAPURACROP, DECODE(IDUTILDTPROC, 'S',DTPROCESSA, SYSDATE)),
                   NVL(DTFINAPURACROP, DECODE(IDUTILDTPROC, 'S',DTPROCESSA, SYSDATE))
            INTO V_DTINICIAL, V_DTFINAL
            FROM APURACAOROP A, PARAMFILIAL P, PARAMGERAL
            WHERE
              (P.CDFILIAL  = C_FILIAL.CDFILCENTPME)  AND
              (P.CDFILIAL  = A.CDFILIAL(+));

         EXCEPTION
            WHEN NO_DATA_FOUND THEN BEGIN
               V_DTINICIAL := SYSDATE;
               V_DTFINAL   := SYSDATE;
            END;
         END;
      ELSE
         BEGIN
            SELECT NVL(DTINIAPURACROP, DECODE(IDUTILDTPROC, 'S',DTPROCESSA, SYSDATE)),
                   NVL(DTFINAPURACROP, DECODE(IDUTILDTPROC, 'S',DTPROCESSA, SYSDATE))
            INTO V_DTINICIAL, V_DTFINAL
            FROM APURACAOROP A, PARAMFILIAL P, PARAMGERAL
            WHERE
              (P.CDFILIAL  = C_FILIAL.CDLISTA)  AND
              (P.CDFILIAL  = A.CDFILIAL(+));

         EXCEPTION
            WHEN NO_DATA_FOUND THEN BEGIN
               V_DTINICIAL := SYSDATE;
               V_DTFINAL   := SYSDATE;
            END;
         END;
      END IF;

      UPDATE APURACAOROP
         SET DTINIAPURACROP = V_DTFINAL  + 1,
             DTFINAPURACROP = V_DTFINAL  + 1
       WHERE CDFILIAL = C_FILIAL.CDFILIAL;

      IF (V_IDTPAPURACAO = '1') OR (V_IDTPAPURACAO = '3') THEN
         APURAC_RESOPERFILI(C_FILIAL.CDFILIAL, V_DTINICIAL, V_DTFINAL , 'N');
      END IF;

      IF (V_IDTPAPURACAO = '2') OR (V_IDTPAPURACAO = '3') THEN
         APURAC_RESOPERFILI_DRF(C_FILIAL.CDFILIAL, V_DTINICIAL, V_DTFINAL , 'N');
      END IF;

   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('PERIODO_APURAC_RESOPERFILI','5.05.062'); END;
/

