/**
 * Retorna dados de horas vendidas, trabalhadas, faturadas e no faturadas
 * a partir das propostas e CDAs lanados pelos colaboradores.
 *
 * @author Ederson Melquades da Cunha <ederson@teknisa.com>
 */

CREATE OR REPLACE
VIEW ETL_PROPOSTASERV AS
   (SELECT CDGERENTEIMPCLI, -- DIMENSO 00320 GERENTE DE IMPLANTAO (OPERADOR)
           CDCLIENTE, -- DIMENSO 00007 CLIENTE (NOME FANTASIA)
           CDOPERFUNC, -- DIMENSO 00319 FUNCIONRIO (OPERADOR)
           CDTIPOSERV, -- DIMENSO 00414 TIPO DE SERVIO
           DSPROPOSETLSERV, -- DIMENSO 00317 PROPOSTA (SERVIO)
           DTSERVPREST,
           CDPROJETO, -- DIMENSO 00292 PROJETO
           NMGERENTEPRJ, -- DIMENSO 00293 GERENTE PROJETO
           SUBSTR(DSPERIODOCSA, 20, 4) DTANOCSA, -- DIMENSO 00025 ANO (YYYY)
           SUBSTR(DSPERIODOCSA, 20, 4) || '/' || SUBSTR(DSPERIODOCSA, 17, 2) || ' - ' || DSPERIODOCSA DSPERIODOCSA, -- DIMENSO 00316 PERODO
           DECODE(NRCONTADOR, 1, QTHRVENDETLSERV, 0) QTHRVENDETLSERV,
           ROUND(QTHRTRABETLSERV, 2) QTHRTRABETLSERV,
           ROUND(QTHRFATUETLSERV, 2) QTHRFATUETLSERV,
           ROUND(QTHRDESLOCFATETLSERV, 2) QTHRDESLOCFATETLSERV,
           CASE WHEN ROUND(QTHRNFATETLSERV, 2) < 0 THEN 0 ELSE ROUND(QTHRNFATETLSERV, 2) END AS QTHRNFATETLSERV
      FROM (SELECT NVL(PA.CDGERENTEIMPCLI, 'XXXXXXXXXXXX') AS CDGERENTEIMPCLI,
                   SE.CDCLIENTE,
                   OP.CDOPERADOR AS CDOPERFUNC,
                   CS.CDTIPOSERV,
                   SE.CDPROJETO, SE.NMGERENTEPRJ,
                   LTRIM(PR.DSREFEPROPOSFAS || ' ' || CS.NRPROPOSFAS || '-' || CS.NRVERPROPFAS) AS DSPROPOSETLSERV,
                   CASE WHEN (CS.QTSERVCONT IS NULL) OR (CS.QTSERVCONT > 100000) THEN 0 ELSE CS.QTSERVCONT END AS QTHRVENDETLSERV,
                   SUM(1) OVER (PARTITION BY NVL(PA.CDGERENTEIMPCLI, 'XXXXXXXXXXXX'), SE.CDCLIENTE, CS.CDTIPOSERV, LTRIM(PR.DSREFEPROPOSFAS || ' ' || CS.NRPROPOSFAS || '-' || CS.NRVERPROPFAS), CASE WHEN (CS.QTSERVCONT IS NULL) OR (CS.QTSERVCONT > 100000) THEN 0 ELSE CS.QTSERVCONT END
                                    ORDER BY NVL(PA.CDGERENTEIMPCLI, 'XXXXXXXXXXXX'), SE.CDCLIENTE, CS.CDTIPOSERV, LTRIM(PR.DSREFEPROPOSFAS || ' ' || CS.NRPROPOSFAS || '-' || CS.NRVERPROPFAS), CASE WHEN (CS.QTSERVCONT IS NULL) OR (CS.QTSERVCONT > 100000) THEN 0 ELSE CS.QTSERVCONT END DESC
                                     ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) NRCONTADOR,
                   SUM(HORACHAR_HORADEC(QTHRTOTAL)) AS QTHRTRABETLSERV,
                   NVL(SUM(QTHRAPROFATU),0) AS QTHRFATUETLSERV,
                   (SUM(HORACHAR_HORADEC(QTHRTOTAL)) - NVL(SUM(QTHRAPROFATU),0)) AS QTHRNFATETLSERV,
                   SUM(HORACHAR_HORADEC(NVL(SE.QTHRDESLOCAMENTOFAT, '0000'))) AS QTHRDESLOCFATETLSERV,
                   SE.DTSERVPREST,
                   CASE WHEN (TO_CHAR(SE.DTSERVPREST, 'DD') >= '21') AND (TO_CHAR(SE.DTSERVPREST, 'DD') <= '31') THEN TO_CHAR(TO_DATE('21/' || TO_CHAR(SE.DTSERVPREST, 'MM/YYYY')), 'DD/MM/YYYY') || ' a ' || TO_CHAR(ADD_MONTHS(TO_DATE('20/' || TO_CHAR(SE.DTSERVPREST, 'MM/YYYY')), 1), 'DD/MM/YYYY')
                        ELSE TO_CHAR(ADD_MONTHS(TO_DATE('21/' || TO_CHAR(SE.DTSERVPREST, 'MM/YYYY')), -1), 'DD/MM/YYYY') || ' a ' || TO_CHAR(TO_DATE('20/' || TO_CHAR(SE.DTSERVPREST, 'MM/YYYY')), 'DD/MM/YYYY')
                    END AS DSPERIODOCSA -- Dimenso 00316 Perodo
              FROM PROPOSTAFAS PR, PARCLIEFAS PA, OPERADOR OP, CONTRATOSERV CS,
                   -- SUBSTITUI SERVPREST SE PELO SELECT ABAIXO QUE INCLUI UM CSA FICTICIO
                   -- NA DATA DE INCLUSAO DO SERVIO QUANDO ESTE AINDA NO TEM CSA
                   (SELECT SE.CDCLIENTE, SE.DTSERVPREST, SE.NRPROPOSFAS,
                           SE.NRVERPROPFAS, SE.CDTIPOSERV, SE.NRSERVCONT,
                           SE.CDEMPRESA, SE.CDFUNC,
                           NVL(PR.CDPROJETO, 'SEM PROJETO') CDPROJETO, NVL(OP.NMOPERADOR, 'SEM GERENTE') NMGERENTEPRJ,
                           SE.QTHRTOTAL, SE.QTHRAPROFATU, SE.QTHRDESLOCAMENTOFAT
                      FROM SERVPREST SE
                      LEFT JOIN PROJETO PR
                        ON SE.CDPROJETO = PR.CDPROJETO
                      LEFT JOIN OPERADOR OP
                        ON OP.CDOPERADOR = PR.CDOPERESPRJ
                     UNION ALL
                    SELECT CS.CDCLIENTE, CS.DTINCLUSAO DTSERVPREST, CS.NRPROPOSFAS,
                           CS.NRVERPROPFAS, CS.CDTIPOSERV, CS.NRSERVCONT,
                           '01' CDEMPRESA, '1',
                           'SEM PROJETO' CDPROJETO, 'SEM GERENTE' NMGERENTEPRJ,
                           '0000' QTHRTOTAL, NULL QTHRAPROFATU, '0000' QTHRDESLOCAMENTOFAT
                      FROM CONTRATOSERV CS
                     WHERE CS.QTSERVCONT IS NOT NULL
                       AND CS.QTSERVCONT > 0
                       AND CS.QTSERVCONT < 100000
                       AND NOT EXISTS (SELECT SE.*
                                         FROM SERVPREST SE
                                        WHERE SE.NRPROPOSFAS = CS.NRPROPOSFAS
                                          AND SE.NRVERPROPFAS = CS.NRVERPROPFAS
                                          AND SE.CDTIPOSERV = CS.CDTIPOSERV
                                          AND SE.NRSERVCONT = CS.NRSERVCONT)) SE
             WHERE SE.CDCLIENTE NOT IN ('J26269316000177',
                                        'I00000000000132153215',
                                        'J06240810000100',
                                        'J06348006000130',
                                        'F03924269602',
                                        'J05118011000194',
                                        'I00000000000000067084',
                                        'I06917855626')
               AND CS.NRPROPOSFAS = SE.NRPROPOSFAS
               AND CS.NRVERPROPFAS = SE.NRVERPROPFAS
               AND CS.CDTIPOSERV = SE.CDTIPOSERV
               AND CS.NRSERVCONT = SE.NRSERVCONT
               AND OP.CDEMPRESA = SE.CDEMPRESA
               AND OP.CDFUNC = SE.CDFUNC
               AND PA.CDCLIENTE (+) = SE.CDCLIENTE
               AND PA.IDTPFATUCLIE (+) = '5'
               AND PR.NRPROPOSFAS = SE.NRPROPOSFAS
               AND PR.NRVERPROPFAS = SE.NRVERPROPFAS
             GROUP BY PA.CDGERENTEIMPCLI, SE.CDCLIENTE, OP.CDOPERADOR, SE.CDPROJETO, SE.NMGERENTEPRJ,
                      CS.CDTIPOSERV, PR.DSREFEPROPOSFAS || ' ' || CS.NRPROPOSFAS || '-' ||CS.NRVERPROPFAS,
                      CS.QTSERVCONT, SE.DTSERVPREST))
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_PROPOSTASERV','5.50.XXX'); END;
/